
Ruby - Bug #18922

Time at 24:00:00 UTC is not normalized

07/17/2022 01:41 PM - nobu (Nobuyoshi Nakada)

Status: Closed   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 2.7: REQUIRED, 3.0: REQUIRED, 3.1:

DONE

Description

Reported by @mame (Yusuke Endoh).

$ ruby3.0 -e 'p Time.new(2000, 1, 1, 24, 0, 0, "-00:00").to_a[0, 6]'

[0, 0, 0, 2, 1, 2000]

 
$ ruby3.1 -e 'p Time.new(2000, 1, 1, 24, 0, 0, "-00:00").to_a[0, 6]'

[0, 0, 24, 1, 1, 2000]

 
$ ruby3.2 -e 'p Time.new(2000, 1, 1, 24, 0, 0, "-00:00").to_a[0, 6]'

[0, 0, 24, 1, 1, 2000]

Related issues:

Related to Ruby - Bug #19106: Time - Hour 24 with tzinfo to_s bug Closed

Associated revisions

Revision 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0 - 07/17/2022 03:59 PM - nobu (Nobuyoshi Nakada)

[Bug #18922] Normalize time at 24:00:00 UTC

Revision 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0 - 07/17/2022 03:59 PM - nobu (Nobuyoshi Nakada)

[Bug #18922] Normalize time at 24:00:00 UTC

Revision 68903df6 - 07/17/2022 03:59 PM - nobu (Nobuyoshi Nakada)

[Bug #18922] Normalize time at 24:00:00 UTC

Revision 13ee4b2c35bad0f893d5ed5a6fdca62da406f958 - 09/25/2022 03:38 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0: [Backport #18922]

    [Bug #18922] Normalize time at 24:00:00 UTC

    ---

     test/ruby/test_time.rb |  2 ++

     time.c                 | 14 ++++++++++++++

     2 files changed, 16 insertions(+)

Revision 13ee4b2c35bad0f893d5ed5a6fdca62da406f958 - 09/25/2022 03:38 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0: [Backport #18922]

    [Bug #18922] Normalize time at 24:00:00 UTC

    ---

     test/ruby/test_time.rb |  2 ++

     time.c                 | 14 ++++++++++++++

     2 files changed, 16 insertions(+)

Revision 13ee4b2c - 09/25/2022 03:38 AM - nagachika (Tomoyuki Chikanaga)

merge revision(s) 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0: [Backport #18922]

    [Bug #18922] Normalize time at 24:00:00 UTC

    ---
     test/ruby/test_time.rb |  2 ++

     time.c                 | 14 ++++++++++++++

     2 files changed, 16 insertions(+)

History

#1 - 07/17/2022 03:08 PM - nobu (Nobuyoshi Nakada)

- Subject changed from Time at 24:00:00 UTC is not normalized since 3.1 to Time at 24:00:00 UTC is not normalized

- Backport changed from 2.7: DONTNEED, 3.0: DONTNEED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: DONTNEED, 3.1: REQUIRED

Time.new(2000, 1, 1, 24, 0, 0, "Z").to_a[0, 6] returns [0, 0, 24, 1, 1, 2000] since 2.7.

It seems to be a much older bug, just that "Z" was not supported 2.6 and earlier and didn’t appear.

#2 - 07/17/2022 03:11 PM - nobu (Nobuyoshi Nakada)

- Backport changed from 2.7: REQUIRED, 3.0: DONTNEED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED

#3 - 07/17/2022 04:00 PM - nobu (Nobuyoshi Nakada)

- Status changed from Open to Closed

Applied in changeset git|68903df6f6fc548f3bf68fb09ee8b2495dcd28f0.

[Bug #18922] Normalize time at 24:00:00 UTC

#4 - 07/18/2022 12:18 PM - mame (Yusuke Endoh)

As a record: the behavior I found was about Time#inspect, which was clearly wrong.

$ ruby -ve 'p Time.new(2000, 1, 1, 24, 0, 0, "Z")'

ruby 3.1.2p20 (2022-04-12 revision 4491bb740a) [x86_64-linux]

2000-01-01 23:00:00 UTC

 After nobu's patch, it works correctly.

$ ./miniruby -ve 'p Time.new(2000, 1, 1, 24, 0, 0, "Z")'

ruby 3.2.0dev (2022-07-18T10:07:55Z master a74634de10) [x86_64-linux]

2000-01-02 00:00:00 UTC

#5 - 09/25/2022 04:44 AM - nagachika (Tomoyuki Chikanaga)

- Backport changed from 2.7: REQUIRED, 3.0: REQUIRED, 3.1: REQUIRED to 2.7: REQUIRED, 3.0: REQUIRED, 3.1: DONE

ruby_3_1 13ee4b2c35bad0f893d5ed5a6fdca62da406f958 merged revision(s) 68903df6f6fc548f3bf68fb09ee8b2495dcd28f0.

#6 - 11/07/2022 04:19 AM - nobu (Nobuyoshi Nakada)

- Related to Bug #19106: Time - Hour 24 with tzinfo to_s bug added
